# ผมชอบขึ้นลิฟต์
  **ระบบจำลองลิฟต์โดยสาร** ที่สามารถทำงานได้อย่างมีประสิทธิภาพ มีฟังก์ชันพื้นฐานที่ลิฟต์ทั่วไปมี เช่น การเปิดประตูให้นานขึ้น การกดชั้นเพิ่มระหว่างที่ลิฟต์ทำงาน ฯลฯ และยังมีฟังก์ชันพิเศษคือใช้ RFID ในการควบคุมและเก็บข้อมูลการใช้งานของผู้ใช้ โดยมีการเก็บข้อมูลสิทธิในการใช้งานลิฟต์ในฐานข้อมูล แล้วนำข้อมูลการใช้งานและสถานะต่างๆมาแสดงผลในหน้าจอสำหรับผู้ดูแล (Back Office) ทั้งนี้ระบบสามารถนำไปต่อยอดเพื่อใช้ประโยชน์อื่นได้เช่น การนำบางส่วนไปใช้งานจริงและนำข้อมูลที่ระบบเก็บได้มาใช้ในการออกแบบการจัดการลิฟต์โดยสารที่มีประสิทธิภาพมากขึ้นต่อไป

  สามารถทดลองใช้ Back Office ได้ที่ [https://pckl-api.herokuapp.com/bof/](https://pckl-api.herokuapp.com/bof/)




##### โครงงานนี้เป็นส่วนหนึ่งของรายวิชา Embedded System (01204322)
#### ภาควิชาวิศวกรรมคอมพิวเตอร์ คณะวิศวกรรมศาสตร์
### มหาวิทยาลัยเกษตรศาสตร์
ปีการศึกษา 2562 ภาคปลาย

### สมาชิกกลุ่ม "ไปธุระเรียกลากิจ เธอออกจากชีวิตเรียกลาก่อน"
ลำดับที่ | ชื่อ-นามสกุล | รหัสนิสิต | GitHub
:---:|---|---|:------:
1|นาย วรรธนัย สาธุพันธ์ | 6010500117 | WisTiCeJEnT |
2|นาย ธันยา ตันศรีประภาศิริ | 6010500389 | lastthanya |
3|นาย อัฐพงศ์ สมบูรณ์วรากร | 6010500401 | kenkainkane |

### ไฟล์ที่เกี่ยวข้อง
    .
    ├── Database                        << ไฟล์ SQL สำหรับการสร้างฐานข้อมูล
    │   ├── d2hnci5njrck9v_public.event_meaning.sql
    │   ├── d2hnci5njrck9v_public.lift_activity.sql
    │   ├── d2hnci5njrck9v_public.user_activity.sql
    │   ├── d2hnci5njrck9v_public.user_data.sql
    │   └── d2hnci5njrck9v_public.user_permission.sql
    ├── LICENSE.txt                     << เงื่อนไขด้านลิขสิทธิ์
    ├── Node\ ESP32-S
    │   ├── liftcontrol1
    │   │   └── liftcontrol1.ino        << ไฟล์สำหรับควบคุมลิฟต์ที่ 1 '
    │   ├── liftcontrol2
    │   │   └── liftcontrol2.ino        << ไฟล์สำหรับควบคุมลิฟต์ที่ 2
    │   └── mainesp
    │       └── mainesp.ino             << ไฟล์สำหรับควบคุมระบบรวม "
    ├── README.md                       << รายละเอียดงาน
    ├── Server                          << ไฟล์สำหรับควบคุมในส่วน Server
    │   ├── Procfile                    << สำหรับ Heroku PaaS
    │   ├── app.py                      << APIs หลัก (Controller)
    │   ├── pom_chob_khun_lift.py       << ควบคุมการทำงานระบบ
    │   ├── postgresql_api.py           << เชื่อมต่อฐานข้อมูล
    │   ├── requirements.txt            << requirements ของ Python
    │   ├── scan.py                     << จัดการการทำงานระบบลิฟต์
    │   └── templates                   << หน้าเว็บ Back Office
    │       ├── bof.html                << แสดงรายการ BOF ทั้งหมด
    │       ├── lift_activity_list.html << รายการการทำงานของลิฟต์
    │       ├── lift_status.html        << แสดงสถานะลิฟต์
    │       ├── oled_terminal.html      << หน้าแสดงผลภายใน/นอกลิฟต์
    │       ├── user_activity.html      << รายการการใช้งานลิฟต์
    │       ├── user_data.html          << ข้อมูลผู้ใช้
    │       └── user_list.html          << รายการผู้ใช้
    └── schematic.png                   << เอกสารผังวงจร

' ไฟล์สำหรับควบคุมลิฟต์ จะทำการตรวจสอบข้อมูลผู้ใช้จาก RFID แล้วส่งไปตรวจสอบยังฐานข้อมูลบน Server และยังควบคุมงานอื่นๆเช่นการเลือกชั้นและเปิด-ปิดประตูลิฟต์ โดยจะรายงานให้ระบบกลาง(Server)ทราบเพื่อควบคุมการทำงานของส่วนอื่นให้สัมพันธ์กัน

" ไฟล์สำหรับควบคุมระบบรวม ทำหน้าที่สื่อการกับ Server หากตัวลิฟต์มีต้องการและพร้อมที่จะเคลื่อนย้ายไปชั้นไหน นอกจากนี้ยังจับตำแหน่งและปุ่มในแต่ละชั้นรายงานให้ Server ทราบแบบ realtime อีกด้วย

แก้ไขเมื่อวันที่ 28 มีนาคม 2563

* ลิขสิทธิ์ทั้งหมด สำหรับการใช้งานไม่แสวงผลกำไรเท่านั้น โดย LISCENSE.txt ไม่ควบคุมไฟล์ ณ ที่นี้
